<template lang="pug">
  .container-fluid

    // Header

    .row.head.justify-content-around

        app-header#logoBlock
        app-cart-btn#kosmoBlock
        app-account#accBlock

    // MAIN block and sidebars


    .row.mainBlock.justify-content-around

      app-left-bar.blockLeft#blockLeft
      app-middle-bar
      app-right-bar.blockRight#blockRight

    //  BOTTOM block

    .row.mainBlock.justify-content-around
      app-bottom-bar#bottomBlock

    // Modal & Shopping Cart

    app-modal(:cartItems='cartItems')
      template(v-slot:cartPlace='')
        app-shopping-cart(:cartItems='cartItems')

    //  blockLeft_down
    .row.mainBlock.justify-content-around
      app-left-bar.blockLeft-mob


</template>

<script>
import Store from "./components/Store.vue";
import ShoppingCart from "./components/ShoppingCart.vue";
import Header from "./components/Header.vue";
import CartBtn from "./components/CartBtn.vue";
import Account from "./components/Account.vue";
import LeftBar from "./components/LeftBar.vue";
import MiddleBar from "./components/MiddleBar";
import BottomBar from "./components/BottomBar.vue";
import RightBar from "./components/RightBar.vue";
import Form from "./components/Form.vue";
import Modal from "./components/Modal.vue";

export default {
  data() {
    return {
      cartItems: [],
      quantityItems: "",
      toDisableCart: false,
      toDisableMenu: false
    };
  },

  // Logic for tools in admin mode

  methods: {
    changeAdminMode(e) {
      this.toDisableCart = e;
      this.toDisableMenu = e;
    }
  },

  mounted() {
    // Taking our array for cart from LocalStorage

    if (localStorage.getItem("cartItems")) {
      try {
        this.cartItems = JSON.parse(localStorage.getItem("cartItems"));
      } catch (e) {
        localStorage.removeItem("cartItems");
      }
    }

    //------- Script for canvas
    var canvas, stage, exportRoot;
    function init() {
      canvas = document.getElementById("canvas");
      handleComplete();
    }
    function handleComplete() {
      //This function is always called, irrespective of the content. You can use the variable "stage" after it is created in token create_stage.
      exportRoot = new lib.index();
      stage = new createjs.Stage(canvas);
      stage.addChild(exportRoot);
      stage.enableMouseOver();
      //Registers the "tick" event listener.
      createjs.Ticker.setFPS(lib.properties.fps);
      createjs.Ticker.addEventListener("tick", stage);
      //Code to support hidpi screens and responsive scaling.
      (function(isResp, respDim, isScale, scaleType) {
        var lastW,
          lastH,
          lastS = 1;
        window.addEventListener("resize", resizeCanvas);
        resizeCanvas();
        function resizeCanvas() {
          if (window.innerWidth > 1200) {
            var iw = window.innerWidth - 600;
          } else {
            var iw = window.innerWidth - 0;
          }
          var w = lib.properties.width;
          var h = lib.properties.height;
          //var iw = window.innerWidth;
          var ih = window.innerHeight;
          var pRatio = window.devicePixelRatio,
            xRatio = iw / w,
            yRatio = ih / h,
            sRatio = 1;
          if (isResp) {
            if (
              (respDim == "width" && lastW == iw) ||
              (respDim == "height" && lastH == ih)
            ) {
              sRatio = lastS;
            } else if (!isScale) {
              if (iw < w || ih < h) sRatio = Math.min(xRatio, yRatio);
            } else if (scaleType == 1) {
              sRatio = Math.min(xRatio, yRatio);
            } else if (scaleType == 2) {
              sRatio = Math.max(xRatio, yRatio);
            }
          }
          canvas.width = w * pRatio * sRatio;
          canvas.height = h * pRatio * sRatio;
          canvas.style.width = w * sRatio + "px";
          canvas.style.height = h * sRatio + "px";

          bottomBlock.width = w * pRatio * sRatio;
          bottomBlock.style.width = w * sRatio + "px";

          var leftPlace =
            Math.floor((window.innerWidth - canvas.width) / 2) - 270 - 10;
          var rightPlace = leftPlace + canvas.width + 320;

          blockLeft.style.left = leftPlace + "px";
          blockRight.style.left = rightPlace + "px";
          
          if (window.innerWidth > 1200) {
            logoBlock.style.left = leftPlace - 10 + "px";
            accBlock.style.left = rightPlace - 27 + "px";
            accBlock.style.top = 20 + "px";

          } else{
            logoBlock.style.left = 20 + "px"
            logoBlock.style.top = 10 + "px"
          }

          stage.scaleX = pRatio * sRatio;
          stage.scaleY = pRatio * sRatio;
          lastW = iw;
          lastH = ih;
          lastS = sRatio;
        }
      })(true, "both", false, 1);
    }
    init();
    //------- Script for canvas End
  },

  components: {
    appStore: Store,
    appShoppingCart: ShoppingCart,
    appHeader: Header,
    appCartBtn: CartBtn,
    appAccount: Account,
    appLeftBar: LeftBar,
    appRightBar: RightBar,
    appMiddleBar: MiddleBar,
    appBottomBar: BottomBar,
    appForm: Form,
    appModal: Modal
  }
};
</script>

<style lang="scss" scoped>
.bottomPanel {
  display: flex;
  position: relative;
  bottom: 10px;
}

.cont-all {
  width: 100%;
}

.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.3s ease-out;
}

.fade-enter,
.fade-leave-active {
  opacity: 0;
}
</style>
